#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

struct poklon
{
	char *ime_prezime, *poruka;
	int x,y;
	struct poklon *sledeci;
};

#define novi(x) x=(struct poklon *)malloc(sizeof(struct poklon))
#define novi_str(x,n) x=(char *)malloc(n*sizeof(char))

struct poklon *formiraj_listu(void);
void ispisati(struct poklon *p);
struct poklon *krece_deda(struct poklon *p, float m, float *sum, int *trenxg, int *trenyg);

int main(void)
{
	struct poklon *p=NULL, *q=NULL, *kupus=NULL;
	float m;
	float sum=0.0, sumpr=0.0;
	int trenxg=0, trenyg=0;
	p=formiraj_listu();
	printf("Unesite M:\n");
	scanf("%f",&m);
	ispisati(p);
	printf("Deda nije isporucio:\n");
	q=krece_deda(p,m,&sumpr,&trenxg,&trenyg);
	ispisati(q);
	sum+=sumpr;
	while (1)
	{
		kupus=krece_deda(q,m,&sumpr,&trenxg,&trenyg);
		sum+=sumpr;
		if (!kupus)
			break;
		printf("Deka nije isporucio sledece poklone: \n");
		ispisati(kupus);
		q=kupus; //sledeci niz koji ce da gleda je preostale koje nije zavrsio
	}
	printf("Pri isporuci poklona deda je presao ");
	sum/=1000; //vratim metre u kilometre
	printf("%f kilometara.\n",sum); 
	return 0;
}

struct poklon *formiraj_listu(void)
{
	struct poklon *head=NULL, *pom, *temp;
	int n;	
	char str[60];
	for (scanf("%d",&n) ; n ; n--)
	{	
		getchar();
		novi(temp);
		fgets(str,60,stdin);
		novi_str(temp->ime_prezime,strlen(str));
		str[strlen(str)-1]='\0';
		strcpy(temp->ime_prezime,str);
		fgets(str,60,stdin);
		novi_str(temp->poruka,strlen(str));
		str[strlen(str)-1]='\0';
		strcpy(temp->poruka,str);
		scanf("%d",&temp->x);
		scanf("%d",&temp->y);
		temp->sledeci=head;
		head=temp;
	}
	return head;	
}
void ispisati(struct poklon *p)
{
	while (p)
	{
		printf("Ime i prezime deteta: %s\n",p->ime_prezime);
		printf("Poruka: %s\n",p->poruka);
		printf("Kordinate (x,y) = (%d,%d)\n",p->x,p->y);
		p=p->sledeci; 
	}
}
struct poklon *krece_deda(struct poklon *p, float m, float *sum, int *trenxg, int *trenyg)
{
	struct poklon *head=NULL, *pom, *temp;
	*sum=0.0;
	m=m*1000.0; //pretvorim kilometre u metre
	float razsled;
	int trenx=*trenxg, treny=*trenyg;
	while (p)
	{
		razsled=sqrt((float)(p->x-trenx)*(p->x-trenx)+(float)(p->y-treny)*(p->y-treny));
		if (razsled>m)
			continue;
		else
		{
			novi(temp);
			novi_str(temp->ime_prezime,strlen(p->ime_prezime));
			strcpy(temp->ime_prezime,p->ime_prezime);
			novi_str(temp->poruka,strlen(p->poruka));
			strcpy(temp->poruka,p->poruka);
			temp->x=p->x;
			temp->y=p->y;
			trenx=p->x;
			treny=p->y;
			temp->sledeci=head;
			head=temp;
		}
		(*sum)+=razsled;
		trenx=p->x;
		treny=p->y;
		p=p->sledeci;
	}
	*trenxg=trenx;
	*trenyg=treny;
	return head;
}
