#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

 typedef struct poklon_s {
	char ime[30];
	char poruka[30];
	int x,y;
	struct poklon_s* sledeci;
}poklon;

#define novi(x) x=(poklon*)malloc(sizeof(poklon))

void dodaj(poklon** p,char dat[]){
	FILE *f = fopen(dat,"r");
	if (!f){
		printf("Greska pri otvaranju datoteke. \n");
		exit(0);
	}
	int i,n;
	fscanf(f,"%d",&n);
	fgetc(f);
	char pom[30];
	poklon* temp;
	
	for(i = 0;i < n;i++){
		novi(temp);
		if(!temp){
			printf("Greska pri alokaciji za temp");
			exit(0);
		}
		
		fgets(pom,30,f);
		strtok(pom,"\n");
		strcpy(temp->ime,pom);
		fgets(pom,30,f);
		strtok(pom,"\n");
		strcpy(temp->poruka,pom);
		fscanf(f,"%d%d",&temp->x,&temp->y);
		fgetc(f);
		//printf("DEBUG : ime = %s poruka = %s x=%d y=%d",temp->ime,temp->poruka,temp->x,temp->y);
		
		temp->sledeci = *p;
		*p = temp;
	}
}


	

double razdaljina(int x1,int y1,int x2,int y2){
	
	double r =  sqrt( ( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) ));
	return r;
	
}
	
	
void isporuka(poklon**p,int m){
	int x=0,y=0;
	
	poklon* res,*pos,*temp;
	res = *p;
	pos = *p;
	while ( pos && ( razdaljina(x,y,pos->x,pos->y) < m ) ){
		x = pos->x;
		y = pos->y;
		res = pos->sledeci;
		free(pos);
		pos = res;
	}
	if(pos){
		while(pos->sledeci)
			if ( razdaljina(x,y,pos->sledeci->x,pos->sledeci->y) < m){
				temp = pos->sledeci;
				pos = temp->sledeci;
				free(temp);
			}
			else {
				pos = pos->sledeci;
				x = pos->x;
				y = pos->y;
			}
		}

	*p = res;

}

	
void stampaj(poklon*p){
	printf("\n");
	while(p){
		printf("%s %s %d %d\n",p->ime,p->poruka,p->x,p->y);
		p = p->sledeci;
	}
}	
	

int main(int argc,char **argv){
	int m;
	printf("Unesi M :\n");
	scanf("%d",&m);
	poklon* p = NULL;
	dodaj(&p,argv[1]);
	printf("Kreirana lista poklona:\n");
	stampaj(p); 
    isporuka(&p,m);
	printf("Nakon isporuke:\n");	
	stampaj(p);
	

	
	
	
	
	
	return 0;
}	

