#include <stdio.h>

typedef struct
{
    char ime[ 50 ], poruka[ 50 ];

    int x, y;

    struct poklon *p;

} poklon;

void ubaci_na_pocetak( poklon **l, poklon t )
{
    poklon *p = ( poklon * ) malloc( sizeof( poklon ) );

    *p = t;

    p -> p = *l;

    *l = p;
}

void ispisi( poklon *l )
{
    while ( l )
    {
        printf("%s\n%s\n%d %d\n", l -> ime, l -> poruka, l -> x, l -> y );

        l = l -> p;
    }
}

float udaljenost( int x1, int y1, int x2, int y2 )
{
    return sqrt( ( x1 - x2 ) * ( x1 - x2 ) + ( y1 - y2 ) * ( y1 - y2 ) ) * 10.0;
}

void podeli( poklon **l, int m, int x, int y, float *preso )
{
    int moze_dalje = 0;

    while ( *l && udaljenost( x, y, ( *l ) -> x, ( *l ) -> y ) < m )
    {
        moze_dalje = 1;

        *preso += udaljenost( x, y, ( *l ) -> x, ( *l ) -> y );

        x = ( *l ) -> x;

        y = ( *l ) -> y;

        poklon *t = *l;

        *l = ( *l ) -> p;

        free( t );
    }

    if ( ! *l ) return;

    poklon *pre = *l, *t = ( *l ) -> p, *nl = NULL;

    while ( t )
    {
        if ( udaljenost( x, y, t -> x, t -> y ) < m )
        {
            moze_dalje = 1;

            *preso += udaljenost( x, y, t -> x, t -> y );

            x = t -> x;

            y = t -> y;

            pre -> p = t -> p;

            poklon *tpm = t;

            t = t -> p;

            free( tpm );
        }

        else
        {
            ubaci_na_pocetak( &nl, *t );

            t = t -> p;
        }

        ispisi( *l );

        if ( nl && moze_dalje ) podeli( &nl, m, x, y, preso );
    }
}

int main()
{
    int n, m;

    poklon *l = NULL;

    scanf("%d", &n ); getchar();

    while ( n -- )
    {
        poklon t;

        gets( t. ime );

        gets( t. poruka );

        scanf("%d%d", &t. x, &t. y ); getchar();

        ubaci_na_pocetak( &l, t );
    }

    putchar('\n');

    ispisi( l );

    putchar('\n');

    scanf("%d", &m );

    float preso = 0;

    podeli( &l, m, 0, 0, &preso );

    printf("%f", preso );

    return 0;
}
