#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

typedef struct lista
{
	char ime[50];
	char poruka[256];
	int x;
	int y;
	struct lista *sledeci;
} lista;

#define novi(x) x=(lista*)malloc(sizeof(lista));

void Ispisp(lista *p)
{
	if (p==NULL) printf("Lista je prazna\n");
	
	while (p)
	{
		printf("%s\t", p->ime);
		printf("%s\t", p->poruka);
		printf("%d\t", p->x);
		printf("%d\n", p->y);
		p=p->sledeci;
	}
	printf("\n");
}

void Ispisq(lista *p)
{
	if (p==NULL) printf("Lista je prazna\n");
	
	while (p)
	{
		printf("%s\t", p->ime);
		printf("%s\t", p->poruka);
		printf("%d\t", p->x);
		printf("%d\n", p->y);
		p=p->sledeci;
	}
	printf("\n");
}

lista* Ubaci_Na_Pocetak(lista *p,char ime[50], char poruka[256], int x, int y)
{
	lista *q=NULL;
	
	novi(q);
			if (q==NULL)
			{
				printf("Greska pri alokaciji\n");
				exit(0);
			}
	strcpy(q->ime,ime);	
	strcpy(q->poruka,poruka);	
	q->x=x;	
	q->y=y;		

	if (p==NULL)
	{
		p=q;
		q->sledeci=NULL;
	}
	else
	{
		q->sledeci=p;
		p=q;
	}
	return p;
}

lista* Formiraj(lista *p)
{
	int i,n,x,y;
	char ime[50], poruka[256];
	printf("Unesi n\n");
	scanf("%d",&n);
	getchar();
	
	while (i<n)
	{
		fgets(ime,50,stdin);
		fgets(poruka,256,stdin);
		scanf("%d", &x);
		scanf("%d", &y);
		getchar();
		p=Ubaci_Na_Pocetak(p,ime,poruka,x,y);
		i++;
	}
	return p;
}

float Udaljenost(int x1, int y1, int x2, int y2)
{	
	float f;
	x1=(double)x1*10;
	y1=y1*10;
	x2=x2*10;
	y2=y2*10;
	
	f=sqrt(((x1-x2)*(x1-x2)) + (y1-y2)*(y1-y2));
	return f;
}

lista* Ubaci_Novu (lista *d,char ime[50], char poruka[256], int x, int y)
{
	lista *q=NULL;
	
	novi(q);
			if (q==NULL)
			{
				printf("Greska pri alokaciji\n");
				exit(0);
			}
	strcpy(q->ime,ime);	
	strcpy(q->poruka,poruka);	
	q->x=x;	
	q->y=y;		

	if (d==NULL)
	{
		d=q;
		q->sledeci=NULL;
	}
	else
	{
		q->sledeci=d;
		d=q;
	}
	return d;
}
		
lista* Formiraj_Novu(lista *q, lista *p, float m)
{
	int xd=0,yd=0;
	float f=0;
	lista *prethodni=p; 
	
	if (p && ((f=Udaljenost(xd,yd,p->x,p->y))>m)) q=Ubaci_Novu(q,p->ime,p->poruka,p->x,p->y); //za nula, nula, tj prvu
	
	p=p->sledeci;
	
	while (p)
	{
		if (((f=Udaljenost(prethodni->x,prethodni->x,p->x,p->y))>m)) q=Ubaci_Novu(q,p->ime,p->poruka,p->x,p->y);
		prethodni=p;
		p=p->sledeci;
	}
	return q;
}

float Ukupno(lista *p, lista*q)
{
	float f=0, ukupno=0, f2=0;
	lista* prethodni=NULL;
	
	prethodni=p;
	p=p->sledeci;
	f=Udaljenost(0,0,p->x,p->y);
	ukupno=ukupno+f;
	while (p)
	{
		f=Udaljenost(prethodni->x,prethodni->x,p->x,p->y);
		ukupno+=f;
		prethodni=p;
		p=p->sledeci;
	}
	
	f2=Udaljenost(0,0,p->x,p->y);
	ukupno+=f2;
	prethodni=q;
	q=q->sledeci;
	while (q)
	{
		f2=Udaljenost(prethodni->x,prethodni->y,q->x,q->y);
		ukupno+=f2;
		prethodni=p;
		p=p->sledeci;
	}
	return ukupno;
}
//Nakon što isporuči sve poklone iz prve torbe Deda Mraz uzima drugu torbu i nastavlja isporuku po istom
//principu, sve dok ne isporuči sve poklone ili dok, zbog velike udaljenosti, nije moguće da isporuči ni jedan od
//preostalih poklona. Svaki put kada isprazni torbu ispisati sadržaj torbe sa neisporučenim poklonima.		

/*
lista* Isporuciti(lista *p, lista*q)
{
	while (p)
	{
		
	}
	while (q)
	{
	 
	}
}
*/
int main()
{
	float m;
	lista *p=NULL, *q=NULL;
	p=Formiraj(p);
	Ispisp(p);
	printf("Unesi m\n");
	scanf("%f", &m);
	m=m*1000;
	q=Formiraj_Novu(q, p, m);
	Ispisq(q);
	printf("Ukupna kilometraza je %f", Ukupno(p,q));
	return 0;
}
