#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct poklon{
    char *ime;
    char * poruka;
    int x,y;
};

struct lista{
  struct poklon *pok;
  struct lista *rep;
};

#define novi(x) x=(struct lista *)malloc(sizeof(struct lista))

struct poklon *ucitaj_pok(){
    struct poklon *r;
    char s[100];
    
    r=(struct poklon *)malloc(sizeof(struct poklon));
    if(!r){
      printf("Greska pri alokaciji memorije!");
      exit(0);
    }
    
    printf("Ime i Prezime: ");
    scanf("%s", s);
    r->ime=(char *)malloc(sizeof(strlen(s)+1));
    strcpy(r->ime, s);
    
    printf("poruka: ");
    scanf("%s", s);
    r->poruka=(char *)malloc(sizeof(strlen(s)+1));
    strcpy(r->poruka,s);
    
    printf("koordinata x: ");
    scanf("%d", &r->x);
    printf("koordinata y: ");
    scanf("%d", &r->y);
    
    return r;
}

void dodaj(struct lista **p, struct poklon *s){
    struct lista *temp;
    novi(temp);
    if(!temp){
      printf("Greska pri alokaciji memorije!");
      exit(0);
    }
    temp->pok=s;
    temp->rep=NULL;
    if(*p == NULL)
      *p=temp;
    else{
      temp->rep=*p;
      *p=temp;
    }
}

struct lista* form_list(int n){
  struct lista *p;
  struct poklon *s;
  int i;
  p=NULL;
  for(i=0; i<n; i++){
    s=ucitaj_pok();
    dodaj(&p,s);
  }
  
}

void ispisi(struct lista *p){
  struct lista *pom;
  struct poklon *s;
  pom=p;
  while(pom){
    s=pom->pok;
    printf("%s ", s->ime);
    printf("%s ", s->poruka);
    printf("%d %d", s->x, s->y);
    
    pom=pom->rep;
  }
}
float razdaljina(struct poklon *s){
    float rez;
    int x,y;
    x=s->x * 10;
    y=s->y * 10;
    rez=x*x+y*y; 
     
    return rez;
}


struct lista *raznesi(struct lista *p, float m){
  struct lista *q, *pom=p;
  struct poklon *s;
  q=NULL;
  while(pom){
    s=pom->pok;
    if(razdaljina(s)<(m*m)*1000)
      dodaj(&q, pom->pok);
	
    pom=pom->rep;
  }
  
  return q;
}

main(){
  
  int n=5;
  float m;
  struct lista *p, *q;
  p=form_list(n); //formira listu od n=5 poklona
  ispisi(p);
  printf("Unesi kilometrazu: ");
  scanf("%f", &m);
  q=raznesi(p,m); //q je lista koja sadrzi ono sto nije uspeo da raznese
  ispisi(q);

  return 0;
}